/*
  f-cpu/c/registers/registers.h - ASU register ports for the F-CPU simulator
  Copyright (C) 2002 Jaap Stolk (JWS) jwstolk@yahoo.com
  version Sat Jul 13 22:22:00 CEST 2002 : first test

 ------------------------BEGIN-LICENSE------------------------------------
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ---------------------------END-LICENSE-----------------------------------
*/

#ifndef REGISTERS_H
#define REGISTERS_H

#include <f-cpu_config.h>

/* inputs and outputs : */

/* external FF of registers: */
UMAX REG_W0;    /* 2 write ports */
UMAX REG_W1;
UMAX REG_R0;    /* 3 read ports */
UMAX REG_R1;
UMAX REG_R2;
u8   REG_nr_W0; /* 2 write ports addresses */
u8   REG_nr_W1;
u8   REG_nr_R0; /* 3 read ports addresses */
u8   REG_nr_R1;
u8   REG_nr_R2;

/* internal FF between stages: */
UMAX register_value[64];

/* problem : they should be enums !! */

static inline void cycle_registers (void);

#endif /* REGISTERS_H */
